
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>mysql数据库优化 / iVAN</title>

    <meta name="description" content="mysql数据库优化 mysql|数据|数据库|优化 下决心开始学oracle了,用mysql已经有不短的时间了,今天写下这些算是对自己的一个mysql之旅的一个交代吧.以下仅仅是本人在使用mysql过程中的一点个人的体会,也许存在许多纰漏和错误,还请指正!! 首先,为了使一个系统更快,最重要的部分就是基础设计,不过有些东西是现有情况下无法逾越的,比如说系统常见的瓶颈. 我所能想到的: 1:磁盘寻道能力,以高速硬盘(7200转/秒),理论上每秒寻道7200次.这是没有办法改变的,优化的方法是----用多个硬盘,或者把">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">mysql数据库优化</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>mysql|数据|数据库|优化</p>
<p>下决心开始学oracle了,用mysql已经有不短的时间了,今天写下这些算是对自己的一个mysql之旅的一个交代吧.以下仅仅是本人在使用mysql过程中的一点个人的体会,也许存在许多纰漏和错误,还请指正!!</p>
<p>首先,为了使一个系统更快,最重要的部分就是基础设计,不过有些东西是现有情况下无法逾越的,比如说系统常见的瓶颈.</p>
<p>我所能想到的:</p>
<p>1:磁盘寻道能力,以高速硬盘(7200转/秒),理论上每秒寻道7200次.这是没有办法改变的,优化的方法是----用多个硬盘,或者把数据分散存储.</p>
<p>2:硬盘的读写速度,这个速度非常的快(限于本人的知识所限,只知道在每秒几十甚至上百MB).这个更容易解决--可以从多个硬盘上并行读写.</p>
<p>3:cpu.cpu处理内存中的数据,当有相对内存较小的表时,这是最常见的限制因素.</p>
<p>4:内存的限制.当cpu需要超出适合cpu缓存的数据时,缓存的带宽就成了内存的一个瓶颈---不过现在内存大的惊人,一般不会出现这个问题.</p>
<p>第二步:</p>
<p>(本人使用的是学校网站的linux平台(Linux ADVX.Mandrakesoft.com 2.4.3-19mdk ))</p>
<p>1:调节服务器参数</p>
<p>用shell&gt;mysqld-help这个命令声厂一张所有mysql选项和可配置变量的表.输出以下信息:</p>
<p>possible variables for option--set-variable(-o) are:</p>
<p>back_log               current value:5  //要求mysql能有的连接数量.back_log指出在mysql暂停接受连接的时间内有多少个连接请求可以被存在堆栈中</p>
<p>connect_timeout        current value:5 //mysql服务器在用bad handshake(不好翻译)应答前等待一个连接的时间</p>
<p>delayed_insert_timeout current value:200  //一个insert delayed在终止前等待insert的时间</p>
<p>delayed_insert_limit    current value:50   //insert delayed处理器将检查是否有任何select语句未执行,如果有,继续前执行这些语句</p>
<p>delayed_queue_size     current value:1000   //为insert delayed分配多大的队</p>
<p>flush_time             current value:0      //如果被设置为非0,那么每个flush_time 时间,所有表都被关闭</p>
<p>interactive_timeout    current value:28800  //服务器在关上它之前在洋交互连接上等待的时间</p>
<p>join_buffer_size       current value:131072 //用与全部连接的缓冲区大小</p>
<p>key_buffer_size        current value:1048540  //用语索引块的缓冲区的大小,增加它可以更好的处理索引</p>
<p>lower_case_table_names current value:0  //</p>
<p>long_query_time        current value:10  //如果一个查询所用时间大于此时间,slow_queried计数将增加</p>
<p>max_allowed_packet     current value:1048576  //一个包的大小</p>
<p>max_connections        current value:300   //允许同时连接的数量</p>
<p>max_connect_errors     current value:10   //如果有多于该数量的中断连接,将阻止进一步的连接,可以用flush hosts来解决</p>
<p>max_delayed_threads    current value:15   //可以启动的处理insert delayed的数量</p>
<p>max_heap_table_size    current value:16777216  //</p>
<p>max_join_size          current value:4294967295  //允许读取的连接的数量</p>
<p>max_sort_length        current value:1024  //在排序blob或者text时使用的字节数量</p>
<p>max_tmp_tables         current value:32  //一个连接同时打开的临时表的数量</p>
<p>max_write_lock_count   current value:4294967295  //指定一个值(通常很小)来启动mysqld,使得在一定数量的write锁定之后出现read锁定</p>
<p>net_buffer_length      current value:16384  //通信缓冲区的大小--在查询时被重置为该大小</p>
<p>query_buffer_size      current value:0   //查询时缓冲区大小</p>
<p>record_buffer          current value:131072  //每个顺序扫描的连接为其扫描的每张表分配的缓冲区的大小</p>
<p>sort_buffer            current value:2097116  //每个进行排序的连接分配的缓冲区的大小</p>
<p>table_cache            current value:64  //为所有连接打开的表的数量</p>
<p>thread_concurrency     current value:10  //</p>
<p>tmp_table_size         current value:1048576  //临时表的大小</p>
<p>thread_stack           current value:131072  //每个线程的大小</p>
<p>wait_timeout           current value:28800  //服务器在关闭它3之前的一个连接上等待的时间</p>
<p>根据自己的需要配置以上信息会对你帮助.</p>
<p>第三:</p>
<p>1:如果你在一个数据库中创建大量的表,那么执行打开,关闭，创建(表)的操作就会很慢.</p>
<p>2:mysql使用内存</p>
<p>a: 关键字缓存区(key_buffer_size)由所有线程共享</p>
<p>b: 每个连接使用一些特定的线程空间.一个栈(默认为64k,变量thread_stack),一个连接缓冲区(变量net_buffer_length)和一个结果缓冲区(net_buffer_length).特定情况下,连接缓冲区和结果缓冲区被动态扩大到max_allowed_packet.</p>
<p>c:所有线程共享一个基存储器</p>
<p>d:没有内存影射</p>
<p>e:每个做顺序扫描的请求分配一个读缓冲区(record_buffer)</p>
<p>f:所有联结均有一遍完成并且大多数联结甚至可以不用一个临时表完成.最临时的表是基于内存的(heap)表</p>
<p>g:排序请求分配一个排序缓冲区和2个临时表</p>
<p>h:所有语法分析和计算都在一个本地存储器完成</p>
<p>i:每个索引文件只被打开一次,并且数据文件为每个并发运行的线程打开一次</p>
<p>j:对每个blob列的表，一个缓冲区动态的被扩大以便读入blob值</p>
<p>k:所有正在使用的表的表处理器被保存在一个缓冲器中并且作为一个fifo管理.</p>
<p>l:一个mysqladmin flush-tables命令关闭所有不在使用的表并且在当前执行的线程结束时标记所有在使用的表准备关闭</p>
<p>3:mysql锁定表</p>
<p>mysql中所有锁定不会成为死锁.</p>
<p>wirte锁定:</p>
<p>mysql的锁定原理:a:如果表没有锁定,那么锁定;b否则,把锁定请求放入写锁定队列中</p>
<p>read锁定:</p>
<p>mysql的锁定原理:a:如果表没有锁定,那么锁定;b否则,把锁定请求放入读锁定队列中</p>
<p>有时候会在一个表中进行很多的select,insert操作,可以在一个临时表中插入行并且偶尔用临时表的记录更新真正的表</p>
<p>a:用low_priority属性给一个特定的insert,update或者delete较低的优先级</p>
<p>b:max_write_lock_count指定一个值(通常很小)来启动mysqld,使得在一定数量的write锁定之后出现read锁定</p>
<p>c:通过使用set sql_low_priority_updates=1可以从一个特定的线程指定所有的更改应该由较低的优先级完成</p>
<p>d:用high_priority指定一个select</p>
<p>e:如果使用insert....select....出现问题,使用myisam表------因为它支持因为它支持并发的select和insert</p>
<p>4:最基本的优化是使数据在硬盘上占据的空间最小.如果索引做在最小的列上,那么索引也最小.实现方法:</p>
<p>a:使用尽可能小的数据类型</p>
<p>b:如果可能，声明表列为NOT NULL.</p>
<p>c:如果有可能使用变成的数据类型,如varchar(但是速度会受一定的影响)</p>
<p>d:每个表应该有尽可能短的主索引</p>
<p>e:创建确实需要的索引</p>
<p>f:如果一个索引在头几个字符上有唯一的前缀,那么仅仅索引这个前缀----mysql支持在一个字符列的一部分上的索引</p>
<p>g:如果一个表经常被扫描,那么试图拆分它为更多的表</p>
<p>第四步</p>
<p>1:索引的使用,索引的重要性就不说了,功能也不说了,只说怎么做.</p>
<p>首先要明确所有的mysql索引(primary,unique,index)在b树中有存储.索引主要用语:</p>
<p>a:快速找到where指定条件的记录</p>
<p>b:执行联结时,从其他表检索行</p>
<p>c:对特定的索引列找出max()和min()值</p>
<p>d：如果排序或者分组在一个可用键的最前面加前缀，排序或分组一个表</p>
<p>e：一个查询可能被用来优化检索值，而不用访问数据文件．如果某些表的列是数字型并且正好是某个列的前缀，为了更快，值可以从索引树中取出</p>
<p>２：存储或者更新数据的查询速度</p>
<p>　grant的执行会稍稍的减低效率．</p>
<p>　mysql的函数应该被高度的优化．可以用benchmark（loop_count,expression)来找出是否查询有问题</p>
<p>　select的查询速度：如果想要让一个select．．．where．．．更快，我能想到的只有建立索引．可以在一个表上运行myisamchk－－analyze来更好的优化查询．可以用myisamchk－－sort－index－－sort－records＝１来设置用一个索引排序一个索引和数据．</p>
<p>３：mysql优化where子句</p>
<p>3.１：删除不必要的括号：</p>
<p>　（（a AND b) AND c OR (((a AND b) AND (a AND d))))&gt;(a AND b AND c) OR (a AND b AND c AND d)</p>
<p>3.2:使用常数</p>
<p>　（a&lt;b AND b=c) AND a=100 &gt; b&gt;5 AND b=c AND a=5</p>
<p>3.3:删除常数条件</p>
<p>（b&gt;=5 AND b=5) OR (b=6 AND 5=5) OR (b=100 AND 2=3) &gt; b=5 OR b=6</p>
<p>3.4:索引使用的常数表达式仅计算一次</p>
<p>3.5：在一个表中，没有一个where的count(*)直接从表中检索信息</p>
<p>3.6:所有常数的表在查询中在任何其他表之前读出</p>
<p>3.7:对外联结表最好联结组合是尝试了所有可能性找到的</p>
<p>3.8：如果有一个order　by字句和一个不同的group　by子句或者order　by或者group　by包含不是来自联结的第一个表的列，那么创建一个临时表</p>
<p>3.9:如果使用了sql_small_result，那么msyql使用在内存中的一个表</p>
<p>3.10:每个表的索引给查询并且使用跨越少于３０％的行的索引．</p>
<p>3.11在每个记录输出前，跳过不匹配having子句的行</p>
<p>４：优化left　join</p>
<p>在mysql中　a left join b按以下方式实现</p>
<p>a：表b依赖于表a　</p>
<p>b：表a依赖于所有用在left　join条件的表（除了b）</p>
<p>c：所有left　join条件被移到where子句中</p>
<p>d：进行所有的联结优化，除了一个表总是在所有他依赖的表后读取．如果有一个循环依赖，那么将发生错误</p>
<p>e：进行所有的标准的where优化</p>
<p>f：如果在a中有一行匹配where子句，但是在b中没有任何匹配left　join条件，那么，在b中生成的所有设置为ＮＵＬＬ的一行</p>
<p>g：如果使用left　join来找出某些表中不存在的行并且在where部分有column_name IS NULL测试(column_name为NOT NULL列)．那么，mysql在它已经找到了匹配left　join条件的一行后，将停止在更多的行后寻找</p>
<p>５：优化limit</p>
<p>a：如果用limit只选择一行，当mysql需要扫描整个表时，它的作用相当于索引</p>
<p>b：如果使用limit＃与order　by，mysql如果找到了第＃行，将结束排序，而不会排序正个表</p>
<p>c：当结合limit＃和distinct时，mysql如果找到了第＃行，将停止</p>
<p>d：只要mysql已经发送了第一个＃行到客户，mysql将放弃查询</p>
<p>e：limit 0一直会很快的返回一个空集合．</p>
<p>f：临时表的大小使用limit＃计算需要多少空间来解决查询</p>
<p>６：优化insert</p>
<p>插入一条记录的是由以下构成：</p>
<p>a:连接（３）</p>
<p>b:发送查询给服务器（２）</p>
<p>c:分析查询（２）</p>
<p>d:插入记录（１*记录大小）</p>
<p>e：插入索引（１*索引）</p>
<p>f：关闭（１）</p>
<p>以上数字可以看成和总时间成比例</p>
<p>改善插入速度的一些方法：</p>
<p>6.1：如果同时从一个连接插入许多行，使用多个值的insert，这比用多个语句要快</p>
<p>6.2：如果从不同连接插入很多行，使用insert　delayed语句速度更快</p>
<p>6.3: 用myisam，如果在表中没有删除的行，能在select：s正在运行的同时插入行</p>
<p>6.4: 当从一个文本文件装载一个表时，用load　data　infile．这个通常比insert快20</p>
<p>倍</p>
<p>6.5:可以锁定表然后插入－－主要的速度差别是在所有insert语句完成后，索引缓冲区仅被存入到硬盘一次．一般与有不同的insert语句那样多次存入要快．如果能用一个单个语句插入所有的行，锁定就不需要．锁定也降低连接的整体时间．但是对某些线程最大等待时间将上升．例如：</p>
<p>thread 1 does 1000 inserts</p>
<p>thread 2,3 and 4 does 1 insert</p>
<p>thread 5 does 1000 inserts</p>
<p>如果不使用锁定，２，３，４将在１和５之前完成．如果使用锁定，２，３，４，将可能在１和５之后完成．但是整体时间应该快４０％．因为insert，update，delete操作在mysql中是很快的，通过为多于大约５次连续不断的插入或更新一行的东西加锁，将获得更好的整体性能．如果做很多一行的插入，可以做一个lock　tables，偶尔随后做一个unlock　tables（大约每１０００行）以允许另外的线程存取表．这仍然将导致获得好的性能．load　data　infile对装载数据仍然是很快的．</p>
<p>为了对load　data　infile和insert得到一些更快的速度，扩大关键字缓冲区．</p>
<p>７优化update的速度</p>
<p>它的速度依赖于被更新数据的大小和被更新索引的数量</p>
<p>使update更快的另一个方法是推迟修改，然后一行一行的做很多修改．如果锁定表，做一行一行的很多修改比一次做一个快</p>
<p>８优化delete速度</p>
<p>删除一个记录的时间与索引数量成正比．为了更快的删除记录，可以增加索引缓存的大小</p>
<p>从一个表删除所有行比删除这个表的大部分要快的多</p>
<p>第五步</p>
<p>１：选择一种表类型</p>
<p>1.1静态myisam</p>
<p>这种格式是最简单且最安全的格式，它是磁盘格式中最快的．速度来自于数据能在磁盘上被找到的难易程度．当锁定有一个索引和静态格式的东西是，它很简单，只是行长度乘以数量．而且在扫描一张表时，每次用磁盘读取来读入常数个记录是很容易的．安全性来源于如果当写入一个静态myisam文件时导致计算机down掉，myisamchk很容易指出每行在哪里开始和结束，因此，它通常能收回所有记录，除了部分被写入的记录．在mysql中所有索引总能被重建</p>
<p>1.2动态myisam</p>
<p>这种格式每一行必须有一个头说明它有多长．当一个记录在更改期间变长时，它可以在多于一个位置上结束．能使用optimize　tablename或myisamchk整理一张表．如果在同一个表中有像某些varchar或者blob列那样存取／改变的静态数据，将动态列移入另外一个表以避免碎片．</p>
<p>1.2.1压缩myisam，用可选的myisampack工具生成</p>
<p>1.2.2内存</p>
<p>这种格式对小型／中型表很有用．对拷贝／创建一个常用的查找表到洋heap表有可能加快多个表联结，用同样数据可能要快好几倍时间．</p>
<p>select tablename.a,tablename2.a from tablename,tablanem2,tablename3 where</p>
<p>tablaneme.a=tablename2.a and tablename2.a=tablename3.a and tablename2.c!=0;</p>
<p>为了加速它，可以用tablename2和tablename3的联结创建一个临时表，因为用相同列（tablename1.a）查找．</p>
<p>ＣＲＥＡＴＥ　ＴＥＭＰＯＲＡＲＹ　ＴＡＢＬＥ　test TYPE=HEAP</p>
<p>SELECT</p>
<p>tablename2.a as a2,tablename3.a as a3</p>
<p>FROM</p>
<p>tablenam2,tablename3</p>
<p>WHERE</p>
<p>tablename2.a=tablename3.a and c=0;</p>
<p>SELECT tablename.a,test.a3 from tablename,test where tablename.a=test.a1;</p>
<p>SELECT tablename.a,test,a3,from tablename,test where tablename.a=test.a1 and ....;</p>
<p>1.3静态表的特点</p>
<p>1.3.1默认格式．用在表不包含varchar，blob，text列的时候</p>
<p>1.3.2所有的char，numeric和decimal列填充到列宽度</p>
<p>1.3.3非常快</p>
<p>1.3.4容易缓冲</p>
<p>1.3.5容易在down后重建，因为记录位于固定的位置</p>
<p>1.3.6不必被重新组织（用myisamchk），除非是一个巨量的记录被删除并且优化存储大小</p>
<p>1.3.7通常比动态表需要更多的存储空间</p>
<p>1.4动态表的特点</p>
<p>1.4.1如果表包含任何varchar，blob，text列，使用该格式</p>
<p>1.4.2所有字符串列是动态的</p>
<p>1.4.3每个记录前置一个位．</p>
<p>1.4.4通常比定长表需要更多的磁盘空间</p>
<p>1.4.5每个记录仅仅使用所需要的空间，如果一个记录变的很大，它按需要被分成很多段，这导致了记录碎片</p>
<p>1.4.6如果用超过行长度的信息更新行，行被分段．</p>
<p>1.4.7在系统down掉以后不好重建表，因为一个记录可以是多段</p>
<p>1.4.8对动态尺寸记录的期望行长度是３＋（number　of　columns＋７）／８＋(number</p>
<p>of char columns)+packed size of numeric columns+length of strings +(number of</p>
<p>NULL columns+7)/8</p>
<p>对每个连接有６个字节的惩罚．无论何时更改引起记录的变大，都有一个动态记录被连接．每个新连接至少有２０个字节，因此下一个变大将可能在同一个连接中．如果不是，将有另外一个连接．可以用myisamchk　－恶毒检查有多少连接．所有连接可以用myisamchk -r删除．</p>
<p>1.5压缩表的特点</p>
<p>1.5.1一张用myisampack实用程序制作的只读表．</p>
<p>1.5.2解压缩代码存在于所有mysql分发中，以便使没有myisampack的连接也能读取用myisampack压缩的表</p>
<p>1.5.3占据很小的磁盘空间</p>
<p>1.5.4每个记录被单独压缩．一个记录的头是一个定长的（１～～３个字节）这取决于表的最大记录．每列以不同的方式被压缩．一些常用的压缩类型是：</p>
<p>　a:通常对每列有一张不同的哈夫曼表</p>
<p>　b:后缀空白压缩</p>
<p>　c:前缀空白压缩</p>
<p>d:用值０的数字使用１位存储</p>
<p>e:如果整数列的值有一个小范围，列使用最小的可能类型来存储．例如：如果所有的值在０到２５５之间，一个bigint可以作为一个tinyint存储</p>
<p>　g:如果列仅有可能值的一个小集合，列类型被转换到enum</p>
<p>　h:列可以使用上面的压缩方法的组合</p>
<p>1.5.5能处理定长或动态长度的记录，去不能处理blob或者text列</p>
<p>1.5.6能用myisamchk解压缩</p>
<p>mysql能支持不同的索引类型，但一般的类型是isam，这是一个Ｂ树索引并且能粗略的为索引文件计算大小为(key_length+4)*0.67，在所有的键上的总和．</p>
<p>字符串索引是空白压缩的。如果第一个索引是一个字符串，它可将压缩前缀如果字符串列有很多尾部空白或是一个总部能甬道全长的varchar列，空白压缩使索引文件更小．如果很多字符串有相同的前缀．</p>
<p>1.6内存表的特点</p>
<p>mysql内部的heap表使用每偶溢出去的１００％动态哈希并且没有与删除有关的问题．只能通过使用在堆表中的一个索引来用等式存取东西（通常用＇＝＇操作符）</p>
<p>堆表的缺点是：</p>
<p>1.6.1想要同时使用的所有堆表需要足够的额外内存</p>
<p>1.6.2不能在索引的一个部分搜索</p>
<p>1.6.3不能按顺序搜索下一个条目（即，使用这个索引做一个order　by）</p>
<p>1.6.4mysql不能算出在２个值之间大概有多少行．这被优化器使用是用来决定使用哪个索引的，但是在另一个方面甚至不需要磁盘寻道</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-03 04:54:40</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e4%b8%80%e4%b8%aa/" title="一个">一个</a>, <a href="https://www.iamivan.net/tag/mysql/" title="mysql">mysql</a>, <a href="https://www.iamivan.net/tag/%e7%b4%a2%e5%bc%95/" title="索引">索引</a>, <a href="https://www.iamivan.net/tag/value/" title="value">value</a>, <a href="https://www.iamivan.net/tag/%e7%bc%93%e5%86%b2%e5%8c%ba/" title="缓冲区">缓冲区</a>, <a href="https://www.iamivan.net/tag/current/" title="current">current</a>, <a href="https://www.iamivan.net/tag/%e4%bc%98%e5%8c%96%e6%8f%92%e5%85%a5%e9%80%9f%e5%ba%a6/" title="优化插入速度">优化插入速度</a>, <a href="https://www.iamivan.net/tag/%e5%a0%86%e8%a1%a8%e8%ae%b0%e5%bd%95/" title="堆表记录">堆表记录</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>mysql数据库优化的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bamDEmb.html" rel="bookmark">解开发者之痛：中国移动MySQL数据库优化最佳实践</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 章颖数据研发工程师 现任中国移动杭州研发中心数据研发工程师,擅长MySQL故障诊断,性能调优,MySQL高可用技术,曾任中国电信综合平台开发运营中心DBA   开源数据库MySQL比较容易碰到性能瓶颈,为此经常需要对MySQL数据库进行优化,而MySQL数据库优化需要运维DBA与相关开发共同参与,其中MySQL参数及服务器配置优化主要由运维DBA完成,开发则需要从数据类型优化,索引优化,SQL优化三个角度考虑MySQL数据库优化问题,本次分享将从开发角度,看如何实现MySQL数据库优化. 本次			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqRGL2p.html" rel="bookmark">mysql数据库优化与mysql在web性能优化</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				数据库语句:     Ddl(数据定义语言)    alter  create   drop         Dml(数据操作语言)   inset  delete  update       Dtl(数据事务语言)  conmmit  rollback   savepoint       Select       Dcl(数据控制语句) grant赋权限  revoke回收        Mysql数据库优化: 1.  数据库表 要设计合理(符合3NF,有时候也需要适当的逆范式) 2.  Sq			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0NBO7z.html" rel="bookmark">mysql数据库优化需要遵守的原则&lowbar;Mysql</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这是我在网上看到的一篇不错的mysql数据库优化文章,内容说的很全! 1.使用索引来更快地遍历表 缺省情况下建立的索引是非群集索引,但有时它并不是最佳的.在非群集索引下,数据在物理上随机存放在数据页上.合理的索引设计要建立在对各种查询的分析和预测上.一般来说: a.有大量重复值.且经常有范围查询( &gt; ,&lt; ,&gt; =,&lt; =)和order by.group by发生的列,可考虑建立群集索引; b.经常同时存取多列,且每列都含有重复值可考虑建立组合索引; c.组合索引要尽量使关键查询			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mr257OM.html" rel="bookmark">MySQL数据库优化详解&lowbar;Mysql</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				mysql表复制                                                                               复制表结构+复制表数据 mysql&gt; create table t3 like t1; mysql&gt; insert into t3 select * from t1; mysql索引                                                                       			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1N7nop.html" rel="bookmark">MySQL数据库优化技术之索引使用技巧总结&lowbar;Mysql</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例总结了MySQL数据库优化技术的索引用法.分享给大家供大家参考,具体如下: 这里紧接上一篇&lt;MySQL数据库优化技术之配置技巧总结&gt;,进一步分析索引优化的技巧: (七)表的优化 1. 选择合适的数据引擎 MyISAM:适用于大量的读操作的表 InnoDB:适用于大量的写读作的表 2.选择合适的列类型 使用 SELECT * FROM TB_TEST PROCEDURE ANALYSE()可以对这个表的每一个字段进行分析,给出优化列类型建议 3.对于不保存NULL值的列使用NOT NUL			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9NkXvp.html" rel="bookmark">RDS for MySQL 数据库优化【Tech Insight演讲实录】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				分享专家--田杰,专注在关系型数据库和NoSQL数据库技术领域,曾先后就职于路透社和渣打银行,目前在阿里云从事数据库技术支持工作,号称&quot;数据库问题的终结者&quot;. 田杰上台后首先问了一个问题,优化的目的是什么?他提出一个观点:&quot;优化的目的是少做或者不做&quot;.从分析RDS for MySQL 性能优化中常常遇见的性能问题入手,开始了今天的分享.从这些问题入手,田杰分四个部分展开了此次在Tech Insight的分享.SQL数据库和人交流的语言,数据库用的好不好,很大程度上取			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdWZRAM.html" rel="bookmark">【转载】运维角度浅谈MySQL数据库优化</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 运维角度浅谈MySQL数据库优化 2015-06-02 14:22:02 标签:mysql优化   mysql分库分表分区 mysql读写分离 mysql主从复制 原创作品,允许转载,转载时请务必以超链接形式标明文章 原始出处 .作者信息和本声明.否则将追究法律责任.http://lizhenliang.blog.51cto.com/7876557/1657465   一个成熟的数据库架构并不是一开始设计就具备高可用.高伸缩等特性的,它是随着用户量的增加,基础架构才逐渐完善.这篇博文主要谈My			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/YMR6OGM.html" rel="bookmark">mysql数据库优化&lpar;未完&period;&period;&period;&period;待续&period;&period;&period;&period;&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				mysql|数据|数据库|优化 ########################################文件名:mysqloptimize,php                           ##主题: mysql数据库的优化                  ##作者: _Shakespeare(网络骑士)                    ##最后修改时间: 2002--09--20                      ##e-mail: shakespareshm			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/gpkl51z.html" rel="bookmark">mysql数据库优化五步走</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				mysql|数据|数据库|优化     第一步:    1:磁盘寻道能力,以高速硬盘(7200转/秒),理论上每秒寻道7200次.这是没有办法改变的,优化的方法是----用多个硬盘,或者把数据分散存储. 2:硬盘的读写速度,这个速度非常的快,这个更容易解决--可以从多个硬盘上并行读写. 3:cpu.cpu处理内存中的数据,当有相对内存较小的表时,这是最常见的限制因素. 4:内存的限制.当cpu需要超出适合cpu缓存的数据时,缓存的带宽就成了内存的一个瓶颈---不过现在内存大的惊人,一般不会出现这			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMgKjZM.html" rel="bookmark" class="title">NPOI简介</a>
					<div>
						什么是NPOI? NPOI,顾名思义,就是POI的.NET版本.那POI又是什么呢?POI是一套用Java写成的库,能够帮助开 发者在没有安装微软Office的情况下读写Office 97-2003的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/apXd8jp.html" rel="bookmark" class="title">PKI与证书服务应用介绍</a>
					<div>
						第5章-PKI与证书服务应用 一.公钥基础结构 (1).什么是PKI ØPKI(Public Key Infrastructure,公钥基础设施),是通过使用公钥技术和数字签名来确保信息安全,并负责验 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpP1rlz.html" rel="bookmark" class="title">微软推出最新版IE9</a>
					<div>
						新浪科技讯 北京时间3月15日上午消息,微软今天在影视音乐互动大会上宣布推出最新版本Windows Internet Explorer 9(以下简称&quot;IE9&quot;)浏览器,支持39个语 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YbKvdnz.html" rel="bookmark" class="title">jsp预编译问题</a>
					<div>
						js|编译|问题 这个方法是到目前为止进行JSP预编译最方便的途径(&quot;flick-a-switch&quot; 途径),他有许多指出来毫无意义的缺点.如果一个错误在JSP的编译期间或在部署( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2MWRBEb.html" rel="bookmark" class="title">Photoshop合成时尚女性海报图</a>
					<div>
						本教程主要用Photoshop合成光线缠绕的时尚女性海报,教程中主要用素材来完成最终的效果图,教程比较简单,感兴趣的朋友都可以一下下载素材来制作. 本教程主要用Photoshop合成光线缠绕的时尚女性 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0bonQDz.html" rel="bookmark" class="title">asp正则去除img属性的函数</a>
					<div>
						以下是引用片段:&lt;% Response.Write(Server.HTMLEncode(FixImg(&quot;&lt;img onclick=&quot;&quot;if(this.widt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd7yQAM.html" rel="bookmark" class="title">如何管理Websphere应用服务器</a>
					<div>
						概述 WebSphere应用服务器(WAS)是因特网的基础架构软件,也就是我们所说的中间件.它使企业能够开发.部署和集成新一代电子商务应用(如 B2B 的电子交易),并且支持从简单的 Web 发布到企 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqLgAGb.html" rel="bookmark" class="title">Word 2013中如何显示或隐藏页边距空白</a>
					<div>
						在Word2013文档中,用户可以根据需要隐藏或显示页面间的空白部分(即上下页边距,包括页眉和页脚的内容),具体设置步骤如下所述: 第1步,打开Word2013文档窗口,依次单击&quot;文件&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPLeOz.html" rel="bookmark" class="title">关于拷贝构造函数和赋值运算符</a>
					<div>
						重点:包含动态分配成员的类 应提供拷贝构造函数,并重载&quot;=&quot;赋值操作符. 以下讨论中将用到的例子: class CExample { public: CExample(){pBuf ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqLnWKb.html" rel="bookmark" class="title">网店系统建设：JAVA和PHP编程语言分析</a>
					<div>
						随着电子商务在国内成功的推广,京东.苏宁等大型B2C综合网上商城的成功运营,一批批以产业分类的独立网店也如火如荼发展起来.伴随着这股热潮,网店系统等相关衍生开店平台行业也出现喷井式发展.目前,光有一定 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQP2Z0z.html" rel="bookmark" class="title">php对mysql简单读取的实例</a>
					<div>
						  读取mysql数据库 例.  代码如下   &lt;?php     $link=mysql_connect(&quot;localhost&quot;,&quot;root&quot;,&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnY85oM.html" rel="bookmark" class="title">那些令人愉悦的动画特效</a>
					<div>
						  由于静态图片传达信息的有限性,很多动态效果需要设计师通过添加设计说明并配合口述才能表达.这样做的优点是节约时间,有助于实现快速迭代,成本较低;但这样做的缺点是不够直观,很多细节存在于设计师自己的心 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9EX1gM.html" rel="bookmark" class="title">Win8中为IE浏览器添加Flash插件的方法</a>
					<div>
						  1.首先,返回到win8系统的传统桌面位置,找到这台电脑图标,双击打开,进入到win8系统的资源管理器窗口了,在打开的窗口中,在上方的地址栏中输入C:Users用户名AppDataLocalMic ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP82wDp.html" rel="bookmark" class="title">Flash player因缺少插件而导致无法播放</a>
					<div>
						有没有碰到过Flash player因缺少插件而导致无法播放的情况?这种情况该要如何去解决呢? 1.卸载原版本的Flash player,可以到控制面板--添加删除里删除,注:如果控制面板里无法删除, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr3O3Op.html" rel="bookmark" class="title">【Android】Android动态代理为SurfaceHolder添加Hook</a>
					<div>
						本博客将会介绍动态代理在Android应用中的一种使用场景 代理模式 代理模式的作用是为其它对象提供一种代理以控制对这个对象的访问.比如用户调用了一个&quot;吃饭&quot;的方法,如果不依靠代理 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYjL3lp.html" rel="bookmark" class="title">Android中如何读写Word doc&sol; docx和PDF文件？</a>
					<div>
						最近在项目中要生成Word的doc和docx文件,一番百度google之后,发现通过java语言实现的主流是Apache的POI组件.除了POI,这里还有 另一种实现 ,不过我没有去研究,有兴趣的同学 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My3q3Ez.html" rel="bookmark" class="title">Categories  VS Extensions &lpar;分类 vs 扩展&rpar;</a>
					<div>
						转载翻译自:http://rypress.com/tutorials/objective-c/categories 一.Categories(分类)      Categories是一个把单个类定义分 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLmDERz.html" rel="bookmark" class="title">ios-Objective-C正则表达式</a>
					<div>
						问题描述 Objective-C正则表达式 开发应用中,需要正则表达式来判断male和female,应该不区分大小写.然后我查了一些文档说明,弄出下面的代码没有反应 -(BOOL)genderVali ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4NgZjM.html" rel="bookmark" class="title">html-如何消除无src属性的img标签的边框？</a>
					<div>
						问题描述 如何消除无src属性的img标签的边框? img标签中没有src属性或者src属性为空,在部分浏览器中会出现边框,怎么消除? 解决方案 img src没有属性,还能显示吗? 解决方案二: & ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrWZYyp.html" rel="bookmark" class="title">解决方案-C&plus;&plus;实现TCP&sol;UDP测试工具的定时发送</a>
					<div>
						问题描述 C++实现TCP/UDP测试工具的定时发送 VS下用C++实现TCP/UDP测试工具的定时发送功能,求解决方案.有具体的源码参考更好. 解决方案 首先设置好两个控件一个是自动发送的,另一个是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDWrVKp.html" rel="bookmark" class="title">程序-高精度文体TIF图像倾斜校正</a>
					<div>
						问题描述 高精度文体TIF图像倾斜校正 想付费定做一个软件,能使改软件或程序通过文字图像的四个角的黑点纠正角度 日常扫描纸本,希望通过固定的四个角的黑点来纠正扫描过程中偏斜的文字图像,需要高精确度,黑 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myd1R4b.html" rel="bookmark" class="title">&lbrack;MySQL 特性&rsqb; MySQL5&period;6&period;7 对压缩表的改进</a>
					<div>
						5.6.7已经RC,其中关于压缩表部分,引进了大多数Facebook的改进 1.可配置的zlib压缩级别 innodb_compression_level 用于动态调整zlib的压缩级别,从1-9,默 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmKPw3b.html" rel="bookmark" class="title">飞控-Apm下载安装提示错误怎么办</a>
					<div>
						问题描述 Apm下载安装提示错误怎么办 Apm2.8下载完成,点击安装时,弹出对话框安装错误,提示错误为3503 解决方案 看看是不是文件不完整,重新试下或者看看说明书					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwJWjmp.html" rel="bookmark" class="title">贪心法&mdash;&mdash;活动选择问题和背包问题</a>
					<div>
						        今天上午听了米老师讲的算法,感觉收获很多,对于算法更加有信心了.首先,先来宏观看一下:                      这三种算法总的来说,刚开始看的时候不知道怎么下手,但是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bodOYDM.html" rel="bookmark" class="title">LinkedIn 开源其分布式对象存储系统 Ambry</a>
					<div>
						日前,LinkedIn在Github上基于Apache 2许可证协议开源了其分布式对象存储系统Ambry.Ambry是一个是不可变对象的存储系统,非常易于扩展,它能够存储KB到GB大小的不可变对象,并 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkAn27b.html" rel="bookmark" class="title">opencv-怎样将Iplimage图像中的某一个轮廓区域提取出来转化为Iplimage格式</a>
					<div>
						问题描述 怎样将Iplimage图像中的某一个轮廓区域提取出来转化为Iplimage格式 程序中Iplimage图像,利用cvFindContours找到各个轮廓区域,现在想对每个轮廓区域进行腐蚀操作 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3J093z.html" rel="bookmark" class="title">spring mvc-Spring MVC 用umeditor 上传图片的时候imageUp&period;jsp报错</a>
					<div>
						问题描述 Spring MVC 用umeditor 上传图片的时候imageUp.jsp报错 项目是用maven 搭建的 ,新建了一个没用maven的项目可以正常上传..会不会是maven的问题呢?求 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mlm63np.html" rel="bookmark" class="title">tapestry5和spring哪个好一点</a>
					<div>
						问题描述 tapestry5和spring哪个好一点 1.tapestry5和spring哪个好一点? 2.感觉tapestry5大家用的很少,国内查不到好点的文档,有没有推荐的文件? 解决方案 ta ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baqkdwb.html" rel="bookmark" class="title">Waitfor&period;exe后门的实现思路</a>
					<div>
						本文讲的是Waitfor.exe后门的实现思路, 0x00 前言 从Casey Smith‏@subTee的Twitter上获得的一个思路,利用Waitfor.exe有可能实现一种后门机制.  于是我 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQWo5Op.html" rel="bookmark" class="title">上海光通正式关闭《传奇3》服务器</a>
					<div>
						1月27日下午消息,盛大在上月正式获得&lt;传奇3&gt;运营权后,今日中华网宣布正式关闭&lt;传奇3&gt;服务器并发布声明. 关于关闭&lt;传奇3&gt;服务器的说明 各位亲爱的玩家: 韩国 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.039 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
